diff -r -u squid-2.6.STABLE13/src/client_side.c new-STABLE13/src/client_side.c
--- squid-2.6.STABLE13/src/client_side.c	Wed Mar 21 06:26:34 2007
+++ new-STABLE13/src/client_side.c	Sun May 13 00:59:36 2007
@@ -220,8 +220,8 @@
     request_t *request = http->request;
     request->x_forwarded_for_iterator = httpHeaderGetList(
 	&request->header, HDR_X_FORWARDED_FOR);
-    debug(33, 5) ("clientFollowXForwardedForStart: indirect_client_addr=%s XFF='%s'\n",
-	inet_ntoa(request->indirect_client_addr),
+    debug(33, 5) ("clientFollowXForwardedForStart: indirect_client_addr=%s XFF='%s'\n", 
+	sockaddr_ntoa(&request->indirect_client_addr),
 	strBuf(request->x_forwarded_for_iterator));
     clientFollowXForwardedForNext(http);
 }
@@ -232,7 +232,7 @@
     clientHttpRequest *http = data;
     request_t *request = http->request;
     debug(33, 5) ("clientFollowXForwardedForNext: indirect_client_addr=%s XFF='%s'\n",
-	inet_ntoa(request->indirect_client_addr),
+	sockaddr_ntoa(&request->indirect_client_addr),
 	strBuf(request->x_forwarded_for_iterator));
     if (strLen(request->x_forwarded_for_iterator) != 0) {
 	/* check the acl to see whether to believe the X-Forwarded-For header */
@@ -266,9 +266,10 @@
 	const char *p;
 	const char *asciiaddr;
 	int l;
-	struct in_addr addr;
+	struct addrinfo hints, *res;
+
 	debug(33, 5) ("clientFollowXForwardedForDone: indirect_client_addr=%s is trusted\n",
-	    inet_ntoa(request->indirect_client_addr));
+	    sockaddr_ntoa(&request->indirect_client_addr));
 	p = strBuf(request->x_forwarded_for_iterator);
 	l = strLen(request->x_forwarded_for_iterator);
 
@@ -290,16 +291,18 @@
 	while (l > 0 && !(p[l - 1] == ',' || xisspace(p[l - 1])))
 	    l--;
 	asciiaddr = p + l;
-	if (inet_aton(asciiaddr, &addr) == 0) {
+	memset(&hints, 0, sizeof(hints));
+	if (getaddrinfo(asciiaddr, NULL, &hints, &res)) {
 	    /* the address is not well formed; do not use it */
 	    debug(33, 3) ("clientFollowXForwardedForDone: malformed address '%s'\n",
 		asciiaddr);
 	    goto done;
 	}
+	
 	debug(33, 3) ("clientFollowXForwardedForDone: changing indirect_client_addr from %s to '%s'\n",
-	    inet_ntoa(request->indirect_client_addr),
+	    sockaddr_ntoa(&request->indirect_client_addr),
 	    asciiaddr);
-	request->indirect_client_addr = addr;
+	xmemcpy(&request->indirect_client_addr, res->ai_addr, SOCKLEN(res->ai_addr)); 
 	strCut(request->x_forwarded_for_iterator, l);
 	if (!Config.onoff.acl_uses_indirect_client) {
 	    /*
@@ -312,10 +315,10 @@
 	return;
     } else if (answer == ACCESS_DENIED) {
 	debug(33, 5) ("clientFollowXForwardedForDone: indirect_client_addr=%s not trusted\n",
-	    inet_ntoa(request->indirect_client_addr));
+	    sockaddr_ntoa(&request->indirect_client_addr));
     } else {
 	debug(33, 5) ("clientFollowXForwardedForDone: indirect_client_addr=%s nothing more to do\n",
-	    inet_ntoa(request->indirect_client_addr));
+	    sockaddr_ntoa(&request->indirect_client_addr));
     }
   done:
     /* clean up, and pass control to clientAccessCheck */
@@ -326,10 +329,10 @@
 	 * instead of the direct client.
 	 */
 	ConnStateData *conn = http->conn;
-	conn->log_addr = request->indirect_client_addr;
-	conn->log_addr.s_addr &= Config.Addrs.client_netmask.s_addr;
+	xmemcpy(&conn->log_addr, &request->indirect_client_addr, 
+		sizeof(struct sockaddr_storage));
 	debug(33, 3) ("clientFollowXForwardedForDone: setting log_addr=%s\n",
-	    inet_ntoa(conn->log_addr));
+	    sockaddr_ntoa(&conn->log_addr));
     }
     stringClean(&request->x_forwarded_for_iterator);
     http->acl_checklist = NULL;	/* XXX do we need to aclChecklistFree() ? */
@@ -602,12 +605,14 @@
 	http->uri = xstrdup(urlCanonical(new_request));
 	new_request->http_ver = old_request->http_ver;
 	httpHeaderAppend(&new_request->header, &old_request->header);
-	new_request->client_addr = old_request->client_addr;
+	xmemcpy(&new_request->client_addr, &old_request->client_addr,
+		sizeof(struct sockaddr_storage));
 	new_request->client_port = old_request->client_port;
 #if FOLLOW_X_FORWARDED_FOR
 	new_request->indirect_client_addr = old_request->indirect_client_addr;
 #endif /* FOLLOW_X_FORWARDED_FOR */
-	new_request->my_addr = old_request->my_addr;
+	xmemcpy(&new_request->my_addr, &old_request->my_addr,
+		sizeof(struct sockaddr_storage));
 	new_request->my_port = old_request->my_port;
 	new_request->client_port = old_request->client_port;
 	new_request->flags = old_request->flags;
@@ -1282,7 +1287,8 @@
 	    http->al.http.code = mem->reply->sline.status;
 	    http->al.http.content_type = strBuf(mem->reply->content_type);
 	}
-	http->al.cache.caddr = conn->log_addr;
+	xmemcpy(&http->al.cache.caddr, &conn->log_addr,
+		sizeof(struct sockaddr_storage));
 	http->al.cache.size = http->out.size;
 	http->al.cache.code = http->log_type;
 	http->al.cache.msec = tvSubMsec(http->start, current_time);
@@ -1324,7 +1330,7 @@
 	    http->al.reply = http->reply;
 	    accessLogLog(&http->al, http->acl_checklist);
 	    clientUpdateCounters(http);
-	    clientdbUpdate(conn->peer.sin_addr, http->log_type, PROTO_HTTP, http->out.size);
+	    clientdbUpdate(&conn->peer, http->log_type, PROTO_HTTP, http->out.size);
 	}
     }
     if (http->acl_checklist)
@@ -1380,7 +1386,7 @@
     clientHttpRequest *http;
     debug(33, 3) ("connStateFree: FD %d\n", fd);
     assert(connState != NULL);
-    clientdbEstablished(connState->peer.sin_addr, -1);	/* decrement */
+    clientdbEstablished(&connState->peer, -1);	/* decrement */
     n = connState->reqs.head;
     while (n != NULL) {
 	http = n->data;
@@ -1538,11 +1544,11 @@
     }
 #if USE_USERAGENT_LOG
     if ((str = httpHeaderGetStr(req_hdr, HDR_USER_AGENT)))
-	logUserAgent(fqdnFromAddr(http->conn->log_addr), str);
+	logUserAgent(fqdnFromAddr(&http->conn->log_addr), str);
 #endif
 #if USE_REFERER_LOG
     if ((str = httpHeaderGetStr(req_hdr, HDR_REFERER)))
-	logReferer(fqdnFromAddr(http->conn->log_addr), str,
+	logReferer(fqdnFromAddr(&http->conn->log_addr), str,
 	    http->log_uri);
 #endif
 #if FORW_VIA_DB
@@ -3076,7 +3082,7 @@
 #if SIZEOF_SQUID_OFF_T <= 4
     if (http->out.size > 0x7FFF0000) {
 	debug(33, 1) ("WARNING: closing FD %d to prevent counter overflow\n", fd);
-	debug(33, 1) ("\tclient %s\n", inet_ntoa(http->conn->peer.sin_addr));
+	debug(33, 1) ("\tclient %s\n", sockaddr_ntoa(&http->conn->peer));
 	debug(33, 1) ("\treceived %d bytes\n", (int) http->out.size);
 	debug(33, 1) ("\tURI %s\n", http->log_uri);
 	comm_close(fd);
@@ -3085,7 +3091,7 @@
 #if SIZEOF_SQUID_OFF_T <= 4
     if (http->out.offset > 0x7FFF0000) {
 	debug(33, 1) ("WARNING: closing FD %d to prevent counter overflow\n", fd);
-	debug(33, 1) ("\tclient %s\n", inet_ntoa(http->conn->peer.sin_addr));
+	debug(33, 1) ("\tclient %s\n", sockaddr_ntoa(&http->conn->peer));
 	debug(33, 1) ("\treceived %d bytes (offset %d)\n", (int) http->out.size,
 	    (int) http->out.offset);
 	debug(33, 1) ("\tURI %s\n", http->log_uri);
@@ -3640,10 +3646,13 @@
 	http->flags.accel = 1;
 	debug(33, 5) ("INTERNAL REWRITE: '%s'\n", http->uri);
     } else if (*url == '/' && conn->port->transparent) {
+	char *q = NULL;
 	int port = 0;
 	const char *host = mime_get_header(req_hdr, "Host");
 	char *portstr;
-	if (host && (portstr = strchr(host, ':')) != NULL) {
+	if (!(q = strchr(host, ']')))
+	    q = host;
+	if (host && (portstr = strchr(q, ':')) != NULL) {
 	    *portstr++ = '\0';
 	    port = atoi(portstr);
 	}
@@ -3663,9 +3672,11 @@
 	if (!host && !conn->transparent && clientNatLookup(conn) == 0)
 	    conn->transparent = 1;
 	if (!host && conn->transparent) {
-	    port = ntohs(conn->me.sin_port);
+		port = (conn->me.ss_family == AF_INET6) ? 
+			ntohs(((struct sockaddr_in6 *)&conn->me)->sin6_port) :
+			ntohs(((struct sockaddr_in *)&conn->me)->sin_port);
 	    if (!host)
-		host = inet_ntoa(conn->me.sin_addr);
+		host = sockaddr_ntoa(&conn->me);
 	}
 	if (host) {
 	    size_t url_sz = 10 + strlen(host) + 6 + strlen(url) + 32 + Config.appendDomainLen;
@@ -3697,9 +3708,13 @@
 	if (*url != '/') {
 	    /* Fully qualified URL. Nothing special to do */
 	} else if (vhost && (t = mime_get_header(req_hdr, "Host"))) {
-	    char *portstr = strchr(t, ':');
+	    char *portstr, *q; 
 	    int port = 0;
 	    size_t url_sz = strlen(url) + 32 + Config.appendDomainLen + strlen(t);
+	    
+	    if (!(q = strchr(t, ']')))
+		q = t;
+	    portstr = strchr(q, ':');
 	    if (portstr) {
 		*portstr++ = '\0';
 		port = atoi(portstr);
@@ -3728,7 +3743,7 @@
 	    http->uri = xcalloc(url_sz, 1);
 	    snprintf(http->uri, url_sz, "%s://%s:%d%s",
 		http->conn->port->protocol,
-		inet_ntoa(http->conn->me.sin_addr),
+		sockaddr_ntoa(&http->conn->me),
 		vport, url);
 	    debug(33, 5) ("VPORT REWRITE: '%s'\n", http->uri);
 	} else if (internalCheck(url)) {
@@ -3915,7 +3930,8 @@
 	    if (parser_return_code < 0) {
 		debug(33, 1) ("clientReadRequest: FD %d (%s:%d) Invalid Request\n", fd, fd_table[fd].ipaddr, fd_table[fd].remote_port);
 		err = errorCon(ERR_INVALID_REQ, HTTP_BAD_REQUEST, NULL);
-		err->src_addr = conn->peer.sin_addr;
+		xmemcpy(&err->src_addr, &conn->peer, 
+			sizeof(struct sockaddr_storage));
 		err->request_hdrs = xstrdup(conn->in.buf);
 		http->log_type = LOG_TCP_DENIED;
 		http->entry = clientCreateStoreEntry(http, method, null_request_flags);
@@ -3926,7 +3942,8 @@
 	    if ((request = urlParse(method, http->uri)) == NULL) {
 		debug(33, 5) ("Invalid URL: %s\n", http->uri);
 		err = errorCon(ERR_INVALID_URL, HTTP_BAD_REQUEST, NULL);
-		err->src_addr = conn->peer.sin_addr;
+		xmemcpy(&err->src_addr, &conn->peer, 
+			sizeof(struct sockaddr_storage));
 		err->url = xstrdup(http->uri);
 		http->al.http.code = err->http_status;
 		http->log_type = LOG_TCP_DENIED;
@@ -3977,14 +3994,22 @@
 	    request->content_length = httpHeaderGetSize(&request->header,
 		HDR_CONTENT_LENGTH);
 	    request->flags.internal = http->flags.internal;
-	    request->client_addr = conn->peer.sin_addr;
-	    request->client_port = conn->peer.sin_port;
+	    xmemcpy(&request->client_addr, &conn->peer,
+			sizeof(struct sockaddr_storage));
+	    request->client_port = (conn->peer.ss_family == AF_INET6) ? 
+			ntohs(((struct sockaddr_in6 *)&conn->peer)->sin6_port) :
+			ntohs(((struct sockaddr_in *)&conn->peer)->sin_port);
 #if FOLLOW_X_FORWARDED_FOR
 	    request->indirect_client_addr = request->client_addr;
 #endif /* FOLLOW_X_FORWARDED_FOR */
-	    request->my_addr = conn->me.sin_addr;
-	    request->my_port = ntohs(conn->me.sin_port);
-	    request->client_port = ntohs(conn->peer.sin_port);
+	    xmemcpy(&request->my_addr, &conn->me,
+			sizeof(struct sockaddr_storage));
+	    request->my_port = (conn->me.ss_family == AF_INET6) ? 
+			ntohs(((struct sockaddr_in6 *)&conn->me)->sin6_port) :
+			ntohs(((struct sockaddr_in *)&conn->me)->sin_port);
+	    request->client_port = (conn->peer.ss_family == AF_INET6) ? 
+			ntohs(((struct sockaddr_in6 *)&conn->peer)->sin6_port) :
+			ntohs(((struct sockaddr_in *)&conn->peer)->sin_port);
 	    request->http_ver = http->http_ver;
 	    if (!urlCheckRequest(request) ||
 		httpHeaderHas(&request->header, HDR_TRANSFER_ENCODING)) {
@@ -4029,7 +4054,7 @@
 		if (!DLINK_ISEMPTY(conn->reqs) && DLINK_HEAD(conn->reqs) == http)
 		    clientCheckFollowXForwardedFor(http);
 		else {
-		    debug(33, 1) ("WARNING: pipelined CONNECT request seen from %s\n", inet_ntoa(http->conn->peer.sin_addr));
+		    debug(33, 1) ("WARNING: pipelined CONNECT request seen from %s\n", sockaddr_ntoa(&http->conn->peer));
 		    debugObj(33, 1, "Previous request:\n", ((clientHttpRequest *) DLINK_HEAD(conn->reqs))->request,
 			(ObjPackMethod) & httpRequestPackDebug);
 		    debugObj(33, 1, "This request:\n", request, (ObjPackMethod) & httpRequestPackDebug);
@@ -4050,7 +4075,8 @@
 		debug(33, 1) ("Config 'request_header_max_size'= %ld bytes.\n",
 		    (long int) Config.maxRequestHeaderSize);
 		err = errorCon(ERR_TOO_BIG, HTTP_REQUEST_ENTITY_TOO_LARGE, NULL);
-		err->src_addr = conn->peer.sin_addr;
+		xmemcpy(&err->src_addr, &conn->peer,
+			sizeof(struct sockaddr_storage));
 		http = parseHttpRequestAbort(conn, "error:request-too-large");
 		/* add to the client request queue */
 		dlinkAddTail(http, &http->node, &conn->reqs);
@@ -4262,7 +4288,8 @@
 	 * Generate an error
 	 */
 	err = errorCon(ERR_LIFETIME_EXP, HTTP_REQUEST_TIMEOUT, NULL);
-	err->src_addr = conn->peer.sin_addr;
+	xmemcpy(&err->src_addr, &conn->peer,
+		sizeof(struct sockaddr_storage));
 	err->url = xstrdup("N/A");
 	/*
 	 * Normally we shouldn't call errorSend() in client_side.c, but
@@ -4301,7 +4328,7 @@
     clientHttpRequest *http = data;
     ConnStateData *conn = http->conn;
     debug(33, 1) ("WARNING: Closing client %s connection due to lifetime timeout\n",
-	inet_ntoa(conn->peer.sin_addr));
+	sockaddr_ntoa(&conn->peer));
     debug(33, 1) ("\t%s\n", http->uri);
     comm_close(fd);
 }
@@ -4411,7 +4438,7 @@
 clientNatLookup(ConnStateData * conn)
 {
     socklen_t sock_sz = sizeof(conn->me);
-    struct in_addr orig_addr = conn->me.sin_addr;
+    struct in_addr orig_addr = ((struct sockaddr_in *)&conn->me)->sin_addr;
     static time_t last_reported = 0;
     /* If the call fails the address structure will be unchanged */
     if (getsockopt(conn->fd, SOL_IP, SO_ORIGINAL_DST, &conn->me, &sock_sz) != 0) {
@@ -4421,8 +4448,8 @@
 	}
 	return -1;
     }
-    debug(33, 5) ("clientNatLookup: addr = %s", inet_ntoa(conn->me.sin_addr));
-    if (orig_addr.s_addr != conn->me.sin_addr.s_addr)
+    debug(33, 5) ("clientNatLookup: addr = %s", sockaddr_ntoa(&conn->me));
+    if (orig_addr.s_addr != ((struct sockaddr_in *)&conn->me)->sin_addr.s_addr)
 	return 0;
     else
 	return -1;
@@ -4493,16 +4520,16 @@
     int fd = -1;
     fde *F;
     ConnStateData *connState = NULL;
-    struct sockaddr_in peer;
-    struct sockaddr_in me;
+    struct sockaddr_storage peer;
+    struct sockaddr_storage me;
     int max = INCOMING_HTTP_MAX;
 #if USE_IDENT
     static aclCheck_t identChecklist;
 #endif
     commSetSelect(sock, COMM_SELECT_READ, httpAccept, data, 0);
     while (max-- && !httpAcceptDefer(sock, NULL)) {
-	memset(&peer, '\0', sizeof(struct sockaddr_in));
-	memset(&me, '\0', sizeof(struct sockaddr_in));
+	memset(&peer, '\0', sizeof(struct sockaddr_storage));
+	memset(&me, '\0', sizeof(struct sockaddr_storage));
 	if ((fd = comm_accept(sock, &peer, &me)) < 0) {
 	    if (!ignoreErrno(errno))
 		debug(50, 1) ("httpAccept: FD %d: accept failure: %s\n",
@@ -4515,27 +4542,36 @@
 	connState = cbdataAlloc(ConnStateData);
 	connState->port = s;
 	cbdataLock(connState->port);
-	connState->peer = peer;
-	connState->log_addr = peer.sin_addr;
+	xmemcpy(&connState->peer, &peer,
+		sizeof(struct sockaddr_storage));
+	xmemcpy(&connState->log_addr, &peer,
+		sizeof(struct sockaddr_storage));
+/*
 	connState->log_addr.s_addr &= Config.Addrs.client_netmask.s_addr;
-	connState->me = me;
+*/
+	xmemcpy(&connState->me, &me,
+		sizeof(struct sockaddr_storage));
 	connState->fd = fd;
 	connState->pinning.fd = -1;
 	connState->in.buf = memAllocBuf(CLIENT_REQ_BUF_SZ, &connState->in.size);
 	comm_add_close_handler(fd, connStateFree, connState);
 	if (Config.onoff.log_fqdn)
-	    fqdncache_gethostbyaddr(peer.sin_addr, FQDN_LOOKUP_IF_MISS);
+	    fqdncache_gethostbyaddr(&peer, FQDN_LOOKUP_IF_MISS);
 	commSetTimeout(fd, Config.Timeout.request, requestTimeout, connState);
 #if USE_IDENT
-	identChecklist.src_addr = peer.sin_addr;
-	identChecklist.my_addr = me.sin_addr;
-	identChecklist.my_port = ntohs(me.sin_port);
+	xmemcpy(&identChecklist.src_addr, &peer,
+		sizeof(struct sockaddr_storage));
+	xmemcpy(&identChecklist.my_addr, &me,
+		sizeof(struct sockaddr_storage));
+	identChecklist.my_port = (me.ss_family == AF_INET6) ? 
+		ntohs(((struct sockaddr_in6 *)&me)->sin6_port) :
+		ntohs(((struct sockaddr_in *)&me)->sin_port) ;
 	if (aclCheckFast(Config.accessList.identLookup, &identChecklist))
 	    identStart(&me, &peer, clientIdentDone, connState);
 #endif
 	commSetSelect(fd, COMM_SELECT_READ, clientReadRequest, connState, 0);
 	commSetDefer(fd, clientReadDefer, connState);
-	clientdbEstablished(peer.sin_addr, 1);
+	clientdbEstablished(&peer, 1);
 	incoming_sockets_accepted++;
     }
 }
@@ -4653,8 +4689,8 @@
     https_port_list *s = data;
     int fd = -1;
     ConnStateData *connState = NULL;
-    struct sockaddr_in peer;
-    struct sockaddr_in me;
+    struct sockaddr_storage peer;
+    struct sockaddr_storage me;
     int max = INCOMING_HTTP_MAX;
 #if USE_IDENT
     static aclCheck_t identChecklist;
@@ -4662,8 +4698,8 @@
     commSetSelect(sock, COMM_SELECT_READ, httpsAccept, s, 0);
     while (max-- && !httpAcceptDefer(sock, NULL)) {
 	fde *F;
-	memset(&peer, '\0', sizeof(struct sockaddr_in));
-	memset(&me, '\0', sizeof(struct sockaddr_in));
+	memset(&peer, '\0', sizeof(struct sockaddr_storage));
+	memset(&me, '\0', sizeof(struct sockaddr_storage));
 	if ((fd = comm_accept(sock, &peer, &me)) < 0) {
 	    if (!ignoreErrno(errno))
 		debug(50, 1) ("httpsAccept: FD %d: accept failure: %s\n",
@@ -4675,25 +4711,34 @@
 	connState = cbdataAlloc(ConnStateData);
 	connState->port = (http_port_list *) s;
 	cbdataLock(connState->port);
-	connState->peer = peer;
-	connState->log_addr = peer.sin_addr;
+	xmemcpy(&connState->peer, &peer,
+	    sizeof(struct sockaddr_storage));
+	xmemcpy(&connState->log_addr, &peer,
+	    sizeof(struct sockaddr_storage));
+/*
 	connState->log_addr.s_addr &= Config.Addrs.client_netmask.s_addr;
-	connState->me = me;
+*/
+	xmemcpy(&connState->me, &me,
+	    sizeof(struct sockaddr_storage));
 	connState->fd = fd;
 	connState->pinning.fd = -1;
 	connState->in.buf = memAllocBuf(CLIENT_REQ_BUF_SZ, &connState->in.size);
 	comm_add_close_handler(fd, connStateFree, connState);
 	if (Config.onoff.log_fqdn)
-	    fqdncache_gethostbyaddr(peer.sin_addr, FQDN_LOOKUP_IF_MISS);
+	    fqdncache_gethostbyaddr(&peer, FQDN_LOOKUP_IF_MISS);
 	commSetTimeout(fd, Config.Timeout.request, requestTimeout, connState);
 #if USE_IDENT
-	identChecklist.src_addr = peer.sin_addr;
-	identChecklist.my_addr = me.sin_addr;
+	xmemcpy(&identChecklist.src_addr, &peer,
+		sizeof(struct sockaddr_storage));
+	xmemcpy(&identChecklist.my_addr, &me,
+		sizeof(struct sockaddr_storage));
+/*
 	identChecklist.my_port = ntohs(me.sin_port);
+*/
 	if (aclCheckFast(Config.accessList.identLookup, &identChecklist))
 	    identStart(&me, &peer, clientIdentDone, connState);
 #endif
-	clientdbEstablished(peer.sin_addr, 1);
+	clientdbEstablished(&peer, 1);
 	incoming_sockets_accepted++;
 	httpsAcceptSSL(connState, s->sslContext);
     }
@@ -4831,6 +4876,7 @@
 {
     http_port_list *s;
     int fd;
+    char host[100], port[8];
     for (s = Config.Sockaddr.http; s; s = s->next) {
 	if (MAXHTTPPORTS == NHttpSockets) {
 	    debug(1, 1) ("WARNING: You have too many 'http_port' lines.\n");
@@ -4840,8 +4886,7 @@
 	enter_suid();
 	fd = comm_open(SOCK_STREAM,
 	    IPPROTO_TCP,
-	    s->s.sin_addr,
-	    ntohs(s->s.sin_port),
+	    &s->s,
 	    COMM_NONBLOCKING,
 	    "HTTP Socket");
 	leave_suid();
@@ -4854,12 +4899,14 @@
 	 * peg the CPU with select() when we hit the FD limit.
 	 */
 	commSetDefer(fd, httpAcceptDefer, NULL);
-	debug(1, 1) ("Accepting %s HTTP connections at %s, port %d, FD %d.\n",
+	getnameinfo(&s->s, SOCKLEN(&s->s),
+	    host, 100, port, 8, NI_NUMERICHOST|NI_NUMERICSERV);
+	debug(1, 1) ("Accepting %s HTTP connections at %s, port %s, FD %d.\n",
 	    s->transparent ? "transparently proxied" :
 	    s->accel ? "accelerated" :
 	    "proxy",
-	    inet_ntoa(s->s.sin_addr),
-	    (int) ntohs(s->s.sin_port),
+	    host,
+	    port,
 	    fd);
 	HttpSockets[NHttpSockets++] = fd;
     }
@@ -4882,8 +4929,7 @@
 	enter_suid();
 	fd = comm_open(SOCK_STREAM,
 	    IPPROTO_TCP,
-	    s->http.s.sin_addr,
-	    ntohs(s->http.s.sin_port),
+	    &s->http.s,
 	    COMM_NONBLOCKING,
 	    "HTTPS Socket");
 	leave_suid();
@@ -4893,8 +4939,10 @@
 	commSetSelect(fd, COMM_SELECT_READ, httpsAccept, s, 0);
 	commSetDefer(fd, httpAcceptDefer, NULL);
 	debug(1, 1) ("Accepting HTTPS connections at %s, port %d, FD %d.\n",
-	    inet_ntoa(s->http.s.sin_addr),
-	    (int) ntohs(s->http.s.sin_port),
+	    sockaddr_ntoa(&s->http.s),
+	    (int) s->http.s.ss_family == AF_INET6 ? 
+		ntohs(((struct sockaddr_in6 *)&s->http.s)->sin6_port) :
+		ntohs(((struct sockaddr_in *)&s->http.s)->sin_port) ,
 	    fd);
 	HttpSockets[NHttpSockets++] = fd;
     }
